function trade(){
	console.log("trading");
	
	var currency1 = document.getElementById("currency1").value;
	var currency2 = document.getElementById("currency2").value;
	var amount = document.getElementById("amount").value;

	var fieldData = {
			"State":"Initial",
			"MsgType":"Open", 
			"RequestID":Math.floor(Math.random()*1000001+1000000), 
			"eventSource":"client",
			"ControlAddLeg":"1",
			"TradingProtocol":"ESP",

			"AssetClass":"FX",
			 
			"DealtCurrency":currency1, 
			"TermCurrency":currency2, 
			"BaseCurrency":currency1, 
			"Account":"acct1", 
			"BuySell":"BUY", 
			"Instrument":"/FX/"+currency1+currency2,
			"Amount":amount,
			"Tenor":"SPOT",
			"SettlementDate":"20130221", 
			"Price":"1.54820" 
	};
	var subject = "/PRIVATE/TRADE/FX";
	streamLink.publishToSubject(subject, fieldData, {
		onCommandOk : function(subject) {
			console.log("Publish to " + subject + " succeeded.");
		},
		onCommandError : function(subject, error) {
			console.log("Publish to " + subject + " failed due to " + error.getError()+".");
		}
	});
}

function login(){
	var username = document.getElementById("username").value;
	var password = document.getElementById("password").value
	console.log("logging in as [" + username + "/" + password + "]");
	
	streamLink = caplin.streamlink.StreamLinkFactory.create({
		username : username,
		password : password,
		liberator_urls : "rttp://localhost:18080"
	});
	
	// Define a connection listener.
	var connectionListener = {

		onConnectionStatusChange : 	function(connectionStatusEvent) {
			console.log("StreamLink is now \"" + connectionStatusEvent.getConnectionState() + "\", "+ connectionStatusEvent.getMessage());
		},

		onConnectionFail : function(reason) {
			console.log("Connection Fail : " + reason);
			console.log("Attempting to reconnect in 10 seconds");
			setTimeout(function() {
				console.log("Attempting to reconnect now.");
				streamLink.connect();
			}, 10000);
		}
		
	};
	
	var tradeSubscriptionListener = {

			onSubscriptionStatus : function(subscription, event) {
				console.log(subscription.getSubject() + " is now " + event.getStatus());
			},

			onSubscriptionError : function(subscription, event)	{
				console.log("Error: Subject " + subscription.getSubject() + " is " + event.getError());
			},

			onRecordUpdate : function(subscription, event) {
				console.log(event);
			}
		};
	
	// Register the connection listener and connect.
	streamLink.addConnectionListener(connectionListener);
	
	var subject = "/PRIVATE/TRADE/FX";
	streamLink.subscribe(subject, tradeSubscriptionListener);
	
	
	streamLink.connect();
};

function subscribe(){
	var subject = document.getElementById("subject").value;
	console.log("subscribing to  [" + subject + "]");
	
	var recordSubscriptionListener = {

		onSubscriptionStatus : function(subscription, event) {
				console.log(subscription.getSubject() + " is now " + event.getStatus());
			},

			onSubscriptionError : function(subscription, event)	{
				console.log("Error: Subject " + subscription.getSubject() + " is " + event.getError());
			},

			onRecordUpdate : function(subscription, event) {
				console.log("Update for [" + subscription.getSubject() + "]")
				console.info(event);
			}
		};
	
	streamLink.subscribe(subject, recordSubscriptionListener);
}


